
// *********************************************************************
// *  This software uses the Perseus API which is defined through the  *
// *  following four files of the Microtelecom Software Defined Radio  *
// *  Developer Kit (SDRK):                                            *
// *  main.cpp, perseusdll.cpp, perseusdefs.h, perseusdll.h            *
// *  To use the Perseus hardware you need the perseususb.dll file     *
// *  You also need at least one of the following files:               *
// *  perseus125k24v21.sbs                                             *
// *  perseus250k24v21.sbs                                             *
// *  perseus500k24v21.sbs                                             *
// *  perseus1m24v21.sbs                                               *
// *  perseus2m24v21.sbs                                               *
// *  The dll and the sbs files are copyright protected and only       *
// *  available at the official Microtelecom Internet site:            *
// *  http://www.microtelecom.it                                       *
// *********************************************************************

#include <stdio.h>
#include "wdef.h"
#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "fft2def.h"
#include "fft3def.h"
#include "screendef.h"
#include "sigdef.h"
#include "seldef.h"
#include "blnkdef.h"
#include "caldef.h"
#include "sdrdef.h"
#include "txdef.h"
#include "vernr.h"
#include "keyboard_def.h"
#include "hwaredef.h"
#include "perseusdef.h"
//#include "dlldef.h"
#include "options.h"
#include "conf.h"
#include "thrdef.h"

#include "padef.h"

WAVEFORMATEXTENSIBLE fmt;

DWORD WINAPI winthread_rx_adinput(PVOID arg)
{
char s[40];
int timing_loop_counter,timing_loop_counter_max,initial_skip_flag;
int local_rxadin1_newbuf_ptr;
int local_rxadin2_newbuf_ptr;
double dt1, read_start_time,total_reads;
double total_time2;
MMRESULT mmrs;
WAVEHDR *whdr1, *whdr2;
char *c1, *c2;
short int *c1_isho, *c2_isho;
int *c1_int, *c2_int, *rxin_int;
int i, k;
c1=arg;
sys_func(THRFLAG_OPEN_RX_SNDIN);
if(kill_all_flag) goto rxadin_init_error;
SetThreadPriority(GetCurrentThread(),THREAD_PRIORITY_HIGHEST);
thread_status_flag[THREAD_RX_ADINPUT]=THRFLAG_ACTIVE;
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
local_rxadin1_newbuf_ptr=rxadin1_newbuf_ptr;
local_rxadin2_newbuf_ptr=rxadin2_newbuf_ptr;
screen_loop_counter_max=0.1*snd[RXAD].interrupt_rate;
if(screen_loop_counter_max==0)screen_loop_counter_max=1;
screen_loop_counter=snd[RXAD].interrupt_rate;
timing_loop_counter_max=screen_loop_counter_max;
timing_loop_counter=2.5*timing_loop_counter_max;
if(thread_command_flag[THREAD_SCREEN]!=THRFLAG_NOT_ACTIVE)
  {
  while(thread_status_flag[THREAD_SCREEN]!=THRFLAG_ACTIVE &&
        thread_status_flag[THREAD_SCREEN]!=THRFLAG_IDLE &&
        thread_status_flag[THREAD_SCREEN]!=THRFLAG_SEM_WAIT)
    {
    if(thread_command_flag[THREAD_RX_ADINPUT] ==
                                        THRFLAG_KILL)goto rxadin_init_error;
    lir_sleep(10000);
    }
  }
read_start_time=current_time();
total_reads=0;
initial_skip_flag=1;
if( allow_wse_parport != 0)
  {
  linrad_thread_create(THREAD_HWARE_COMMAND);
  }
while(thread_command_flag[THREAD_RX_ADINPUT] == THRFLAG_ACTIVE)
  {
  timing_loop_counter--;
  if(timing_loop_counter == 0)
    {
    timing_loop_counter=timing_loop_counter_max;
    total_time2=current_time();
    if(initial_skip_flag != 0)
      {
      read_start_time=total_time2;
      total_reads=0;
      initial_skip_flag=0;
      }
    else
      {
      total_reads+=timing_loop_counter_max;
      dt1=total_time2-read_start_time;
      measured_ad_speed=total_reads*snd[RXAD].block_frames/dt1;
      }
    }
  k=rxadin1_newbuf_ptr-local_rxadin1_newbuf_ptr;
  if(k<0)k+=no_of_rx_wavein;
  if(k>=no_of_rx_wavein-2)
    {
    sprintf(s,"RX%s%d",overrun_error_msg,no_of_rx_overrun_errors);
    wg_error(s,WGERR_RXIN);
    }
  if(k<=1)WaitForSingleObject(rxin1_bufready, INFINITE);
  rxin_isho=(void*)(&timf1_char[timf1p_pa]);
  timf1p_pnb=timf1p_pa;
  timf1p_pa=(timf1p_pa+snd[RXAD].block_bytes)&timf1_bytemask;
  whdr1=(WAVEHDR*)rxadin1_newbuf[local_rxadin1_newbuf_ptr];
  if( (whdr1[0].dwFlags & WHDR_DONE) == 0)
    {
    lirerr(1225);
    goto rxadin_error;
    }
  c1=whdr1[0].lpData;
  if(ui.rx_addev_no < 256)
    {
    memcpy(rxin_isho,c1,snd[RXAD].block_bytes);
    if(local_rxadin1_newbuf_ptr==rxadin1_newbuf_ptr)
      {
      sprintf(s,"RX%s%d",overrun_error_msg,no_of_rx_overrun_errors);
      wg_error(s,WGERR_RXIN);
      }
    local_rxadin1_newbuf_ptr++;
    if(local_rxadin1_newbuf_ptr>=no_of_rx_wavein)local_rxadin1_newbuf_ptr=0;
    mmrs=waveInAddBuffer(hwav_rxadin1,whdr1, sizeof(WAVEHDR));
    if(mmrs != MMSYSERR_NOERROR)
      {
      lirerr(1226);
      goto rxadin_error;
      }
    }
  else
    {
    k=rxadin2_newbuf_ptr-local_rxadin2_newbuf_ptr;
    if(k<0)k+=no_of_rx_wavein;
    if(k>=no_of_rx_wavein-2)
      {
      sprintf(s,"RX%s%d",overrun_error_msg,no_of_rx_overrun_errors);
      wg_error(s,WGERR_RXIN);
      }
    if(k<=1)WaitForSingleObject(rxin2_bufready, INFINITE);
    whdr2=(WAVEHDR*)rxadin2_newbuf[local_rxadin2_newbuf_ptr];
    if( (whdr2[0].dwFlags & WHDR_DONE) == 0)
      {
      lirerr(1231);
      goto rxadin_error;
      }
    c2=whdr2[0].lpData;
    if( (ui.rx_input_mode&DWORD_INPUT) == 0)
      {
      k=snd[RXAD].block_bytes>>3;
      c1_isho=(void*)whdr1[0].lpData;
      c2_isho=(void*)whdr2[0].lpData;
      for(i=0; i<k; i++)
        {
        rxin_isho[4*i  ]=c1_isho[2*i  ];
        rxin_isho[4*i+1]=c1_isho[2*i+1];
        rxin_isho[4*i+2]=c2_isho[2*i  ];
        rxin_isho[4*i+3]=c2_isho[2*i+1];
        }
      }
    else
      {
      k=snd[RXAD].block_bytes>>4;
      c1_int=(void*)whdr1[0].lpData;
      c2_int=(void*)whdr2[0].lpData;
      rxin_int=(void*)rxin_isho;
      for(i=0; i<k; i++)
        {
        rxin_int[4*i  ]=c1_int[2*i  ];
        rxin_int[4*i+1]=c1_int[2*i+1];
        rxin_int[4*i+2]=c2_int[2*i  ];
        rxin_int[4*i+3]=c2_int[2*i+1];
        }
      }
    local_rxadin1_newbuf_ptr++;
    local_rxadin2_newbuf_ptr++;
    if(local_rxadin1_newbuf_ptr>=no_of_rx_wavein)local_rxadin1_newbuf_ptr=0;
    if(local_rxadin2_newbuf_ptr>=no_of_rx_wavein)local_rxadin2_newbuf_ptr=0;
    mmrs=waveInAddBuffer(hwav_rxadin1,whdr1, sizeof(WAVEHDR));
    if(mmrs != MMSYSERR_NOERROR)
      {
      lirerr(1232);
      goto rxadin_error;
      }
    mmrs=waveInAddBuffer(hwav_rxadin2,whdr2, sizeof(WAVEHDR));
    if(mmrs != MMSYSERR_NOERROR)
      {
      lirerr(1233);
      goto rxadin_error;
      }
    }
  finish_rx_read(rxin_isho);
  if(kill_all_flag) goto rxadin_error;
  }
rxadin_error:;
close_rx_sndin();
rxadin_init_error:;
thread_status_flag[THREAD_RX_ADINPUT]=THRFLAG_RETURNED;
if(!kill_all_flag)
  {
  while(thread_command_flag[THREAD_RX_ADINPUT] != THRFLAG_NOT_ACTIVE)
    {
    lir_sleep(1000);
    }
  }
if( allow_wse_parport != 0)
  {
  linrad_thread_stop_and_join(THREAD_HWARE_COMMAND);
  }
return 100;
}

VOID CALLBACK rx_adin1(HWAVEIN hwi, UINT iMsg, DWORD dwInst,
                         DWORD dwParam1, DWORD dwParam2)
{
DWORD i;
if(iMsg == WIM_DATA)
  {
  rxadin1_newbuf[rxadin1_newbuf_ptr]=dwParam1;
  rxadin1_newbuf_ptr++;
  if(rxadin1_newbuf_ptr >= no_of_rx_wavein)rxadin1_newbuf_ptr=0;
  SetEvent(rxin1_bufready);
  }
else
  {
  if(iMsg == WIM_CLOSE)
    {
    i=(DWORD)hwi;
    i=dwInst;
    i=dwParam2;
    wave_in_open_flag1=0;
    }
  }
}

VOID CALLBACK rx_adin2(HWAVEIN hwi, UINT iMsg, DWORD dwInst,
                         DWORD dwParam1, DWORD dwParam2)
{
DWORD i;
if(iMsg == WIM_DATA)
  {
  rxadin2_newbuf[rxadin2_newbuf_ptr]=dwParam1;
  rxadin2_newbuf_ptr++;
  if(rxadin2_newbuf_ptr >= no_of_rx_wavein)rxadin2_newbuf_ptr=0;
  SetEvent(rxin2_bufready);
  }
else
  {
  if(iMsg == WIM_CLOSE)
    {
    i=(DWORD)hwi;
    i=dwInst;
    i=dwParam2;
    wave_in_open_flag2=0;
    }
  }
}



int lir_tx_output_samples(void)
{
return 0;
}

int lir_tx_input_samples(void)
{
return 0;
}

void lir_tx_adread(char *buf)
{
buf[0]=0;
/*
int nread;
nread=read(tx_audio_in, buf, tx_read_bytes);
if(nread != tx_read_bytes)lirerr(1283);
*/
}

VOID CALLBACK rx_daout(HWAVEOUT hwi, UINT iMsg, DWORD dwInst,
                         DWORD dwParam1, DWORD dwParam2)
{
DWORD i;
i=(DWORD)hwi;
i=dwInst;
i=dwParam2;
i=iMsg;
i=dwParam1;
if(iMsg == WIM_DATA)
  {
  }
else
  {
  if(iMsg == WIM_CLOSE)
    {
    i=(DWORD)hwi;
    i=dwInst;
    i=dwParam2;
    rx_audio_in=-1;
    }
  else
    {
    if(iMsg == WIM_OPEN)
      {
      rx_audio_in=0;
      }
    }
  }
}



VOID CALLBACK tx_daout(HWAVEOUT hwi, UINT iMsg, DWORD dwInst,
                         DWORD dwParam1, DWORD dwParam2)
{
(void)hwi;
(void)dwInst;
(void)dwParam1;
(void)dwParam2;
if(iMsg == WOM_DONE)
  {
  }
else
  {
  if(iMsg == WOM_CLOSE)
    {
    tx_audio_out=-1;
    }
  else
    {
    if(iMsg == WOM_OPEN)
      {
      tx_audio_out=0;
      }
    }
  }
}

void open_tx_sndout(void)
{
int errcod;
WAVEFORMATEXTENSIBLE wfmt;
MMRESULT mmrs;
int i, k;
if(tx_audio_out != -1)return;
wfmt.Format.wFormatTag = WAVE_FORMAT_EXTENSIBLE;
wfmt.Format.nSamplesPerSec=ui.tx_da_speed;
if(ui.tx_da_bytes == 2)
  {
  wfmt.Samples.wValidBitsPerSample=16;
  wfmt.Format.wBitsPerSample=16;
  }
else
  {
  wfmt.Samples.wValidBitsPerSample=24;
  wfmt.Format.wBitsPerSample=32;
  }
wfmt.SubFormat = KSDATAFORMAT_SUBTYPE_PCM;
wfmt.dwChannelMask = 7;
wfmt.Format.nChannels=ui.tx_da_channels;
wfmt.Format.nBlockAlign=(unsigned int)((wfmt.Format.nChannels *
                                         wfmt.Format.wBitsPerSample) / 8.0);
wfmt.Format.nAvgBytesPerSec=wfmt.Format.nBlockAlign*wfmt.Format.nSamplesPerSec;
wfmt.Format.cbSize=sizeof(WAVEFORMATEXTENSIBLE);;
mmrs=waveOutOpen(&hwav_txdaout, ui.tx_dadev_no,
              (WAVEFORMATEX*)&wfmt, (DWORD)tx_daout, 0, CALLBACK_FUNCTION);
if(mmrs != MMSYSERR_NOERROR)
  {
  lirerr(1234);
  return;
  }
errcod=1237;
tx_waveout_buf=malloc(NO_OF_TX_WAVEOUT*tx_daout_block+wfmt.Format.nBlockAlign);
if(tx_waveout_buf==NULL)goto wave_close;
tx_wave_outhdr=malloc(NO_OF_TX_WAVEOUT*sizeof(WAVEHDR));
if(tx_wave_outhdr==NULL)goto free_waveout;
// ??tx_da_wrbuf=malloc(tx_daout_block);
// ??if(tx_da_wrbuf==NULL)
goto free_outhdr; //


txdaout_newbuf_ptr=0;
for(i=0; i<NO_OF_TX_WAVEOUT; i++)
  {
  k=(int)(tx_waveout_buf+i*tx_daout_block+wfmt.Format.nBlockAlign);
  k&=(-1-wfmt.Format.nBlockAlign);
  tx_wave_outhdr[i].lpData=(char*)(k);
  tx_wave_outhdr[i].dwBufferLength=tx_daout_block;
  tx_wave_outhdr[i].dwBytesRecorded=0;
  tx_wave_outhdr[i].dwUser=1;
  tx_wave_outhdr[i].dwFlags=0;
  tx_wave_outhdr[i].dwLoops=0;
  tx_wave_outhdr[i].lpNext=NULL;
  tx_wave_outhdr[i].reserved=0;
  mmrs=waveOutPrepareHeader(hwav_txdaout, &tx_wave_outhdr[i], sizeof(WAVEHDR));
  txdaout_newbuf[i]=&tx_wave_outhdr[i];
  if(mmrs != MMSYSERR_NOERROR)goto errfree;
  }
snd[TXDA].tot_bytes=NO_OF_TX_WAVEOUT*tx_daout_block;
tx_audio_out=0;
return;
errfree:;
//free(tx_da_wrbuf);
free_outhdr:;
free(tx_wave_outhdr);
free_waveout:;
free(tx_waveout_buf);
wave_close:;
waveOutClose(hwav_txdaout);
tx_audio_out=-1;
lirerr(errcod);
}



void close_tx_sndout(void)
{
/*
if(close(tx_audio_out)==-1)lirerr(231037);
*/
tx_audio_out=-1;
}

void open_tx_sndin(void)
{
}

void close_tx_sndin(void)
{
tx_audio_in=-1;
}

void lir_empty_da_device_buffer(void)
{
#if PORTAUDIO_PRESENT == 1
if( (ui.use_alsa&PORTAUDIO_RX_OUT) != 0)
  {
  return;
  }
#endif
if(rx_audio_out == 0)
  {
  waveOutReset(hwav_rxdaout);
  }
else
  {
  lirerr(745251);
  }
}

void close_rx_sndout(void)
{
MMRESULT mmrs;
WAVEHDR *whdr;
int i;
if(rx_audio_out == -1)return;
#if PORTAUDIO_PRESENT == 1
if( (ui.use_alsa&PORTAUDIO_RX_OUT) != 0)
  {
  close_portaudio_rxda();
  goto freebuf;
  }
#endif
mmrs=waveOutReset(hwav_rxdaout);
if(mmrs != MMSYSERR_NOERROR)lirerr(25344);
for(i=0; i<snd[RXDA].no_of_blocks; i++)
  {
  whdr=rxdaout_newbuf[i];
  while( (whdr[0].dwFlags&WHDR_INQUEUE) != 0)lir_sleep(3000);
  mmrs=waveOutUnprepareHeader(hwav_rxdaout, whdr, sizeof(WAVEHDR));
  if(mmrs != MMSYSERR_NOERROR)lirerr(25144);
  }
mmrs=waveOutClose(hwav_rxdaout);
if(mmrs != MMSYSERR_NOERROR)lirerr(25344);
free(rx_wave_outhdr);
free(rx_waveout_buf);
free(rxdaout_newbuf);
#if PORTAUDIO_PRESENT == 1
freebuf:;
#endif
rx_audio_out=-1;
}

void lir_tx_dawrite(char * buf)
{
buf[0]=0;
}

void lir_rx_dawrite(void)
{
char *c;
WAVEHDR *whdr;
// Wait until there is a buffer ready for us.
whdr=rxdaout_newbuf[rxdaout_newbuf_ptr];
while( (whdr[0].dwFlags&WHDR_INQUEUE) != 0)
  {
  lir_sleep(10000);
  }
c=whdr[0].lpData;
memcpy(c,&daout[daout_px],snd[RXDA].block_bytes);
daout_px=(daout_px+snd[RXDA].block_bytes)&daout_bufmask;
waveOutWrite(hwav_rxdaout,whdr,sizeof(WAVEHDR));
rxdaout_newbuf_ptr++;
if(rxdaout_newbuf_ptr >= snd[RXDA].no_of_blocks)rxdaout_newbuf_ptr=0;
}

void close_rx_sndin(void)
{
if(wave_in_open_flag1 == 0)return;
if(ui.rx_addev_no > 255)
  {
  waveInReset(hwav_rxadin2);
  waveInClose(hwav_rxadin2);
  }
waveInReset(hwav_rxadin1);
waveInClose(hwav_rxadin1);
while(wave_in_open_flag1!=0||wave_in_open_flag2!=0)
  {
  lir_sleep(1000);
  }
free(rx_wave_inhdr);
free(rx_wavein_buf);
CloseHandle(rxin1_bufready);
if(ui.rx_addev_no > 255)CloseHandle(rxin2_bufready);
rxin1_bufready=NULL;
}


void fill_wavefmt(int channels, int bits)
{
fmt.Format.nSamplesPerSec=ui.rx_ad_speed;
if(bits==16)
  {
  fmt.Samples.wValidBitsPerSample=16;
  fmt.Format.wBitsPerSample=16;
  if( (ui.use_alsa&WAVE_FORMAT_EXTENSIBLE_USED) == 0)
    {
    fmt.Format.wFormatTag=WAVE_FORMAT_PCM;
    fmt.Format.cbSize=0;
    }
  else
    {
    fmt.Format.wFormatTag = WAVE_FORMAT_EXTENSIBLE;
    fmt.Format.cbSize=sizeof(WAVEFORMATEXTENSIBLE);
    fmt.SubFormat = KSDATAFORMAT_SUBTYPE_PCM;
    }
  }
else
  {
  if( (ui.use_alsa&WAVE_FORMAT_EXTENSIBLE_USED) == 0)
    {
    lirerr(2654844);
    return;
    }
  fmt.Format.wFormatTag = WAVE_FORMAT_EXTENSIBLE;
  fmt.Samples.wValidBitsPerSample=24;
  fmt.Format.wBitsPerSample=32;
  fmt.Format.cbSize=sizeof(WAVEFORMATEXTENSIBLE);
  fmt.SubFormat = KSDATAFORMAT_SUBTYPE_PCM;
  }
fmt.dwChannelMask = 7;
fmt.Format.nChannels=channels;
fmt.Format.nBlockAlign=fmt.Format.nChannels*fmt.Format.wBitsPerSample/8;
fmt.Format.nAvgBytesPerSec=fmt.Format.nBlockAlign*fmt.Format.nSamplesPerSec;
}

void open_rx_sndin(void)
{
int ch, bits, errcod;
MMRESULT mmrs;
int i, k, dev, devno;
if(wave_in_open_flag1 == 1)
  {
  lirerr(869233);
  return ;
  }
dev=ui.rx_addev_no&255;
ch=ui.rx_ad_channels;
if(ui.rx_addev_no > 255)
  {
  devno=2;
  ch/=2;
  }
else
  {
  devno=1;
  }
if( (ui.rx_input_mode&DWORD_INPUT) == 0)
  {
  bits=16;
  }
else
  {
  bits=24;
  if( (ui.use_alsa&WAVE_FORMAT_EXTENSIBLE_USED) == 0)
    {
    lirerr(1157);
    return ;
    }
  }
fill_wavefmt(ch,bits);
if(fmt.Format.wFormatTag == WAVE_FORMAT_EXTENSIBLE)
  {
  mmrs=waveInOpen(&hwav_rxadin1, dev, (WAVEFORMATEX*)&fmt,
                                    (DWORD)rx_adin1, 0, CALLBACK_FUNCTION);
  }
else
  {
  mmrs=waveInOpen(&hwav_rxadin1, dev, &fmt.Format,
                                    (DWORD)rx_adin1, 0, CALLBACK_FUNCTION);
  }
if(mmrs != MMSYSERR_NOERROR)
  {
  switch (mmrs)
    {
    case MMSYSERR_ALLOCATED:
    lirerr(1192);
    break;

    case MMSYSERR_BADDEVICEID:
    lirerr(1146);
    break;

    case MMSYSERR_NODRIVER:
    lirerr(1147);
    break;


    case MMSYSERR_NOMEM:
    lirerr(1155);
    break;

    case WAVERR_BADFORMAT:
    lirerr(1156);
    break;

    default:
    lirerr(1227);
    break;
    }
  return;
  }
wave_in_open_flag1=1;
rxin1_bufready=CreateEvent( NULL, FALSE, FALSE, NULL);
if(rxin1_bufready== NULL)
  {
  errcod=1223;
  goto errclose;
  }
if(devno==2)
  {
  dev=(ui.rx_addev_no>>8)-1;
  mmrs=waveInOpen(&hwav_rxadin2, dev, (WAVEFORMATEX*)&fmt,
                                     (DWORD)rx_adin2, 0, CALLBACK_FUNCTION);
  if(mmrs != MMSYSERR_NOERROR)
    {
    errcod=1228;
    goto errclose;
    }
  wave_in_open_flag2=1;
  rxin2_bufready=CreateEvent( NULL, FALSE, FALSE, NULL);
  if(rxin2_bufready== NULL)
    {
    errcod=1229;
    goto errclose;
    }
  }
// We read ui.rx_ad_speed*snd[RXAD].framesize bytes per second from hardware.
// The callback routine will give us the data in a block size of
// snd[RXAD].block_bytes/devno.
// Make the number of buffers large enough to hold 0.1 second of data.
no_of_rx_wavein=0.1*(float)(ui.rx_ad_speed*snd[RXAD].framesize)/snd[RXAD].block_bytes;
if(no_of_rx_wavein<4)no_of_rx_wavein=4;
rx_wavein_buf=malloc(no_of_rx_wavein*snd[RXAD].block_bytes+fmt.Format.nBlockAlign);
if(rx_wavein_buf == NULL)
  {
  errcod=1236;
  goto errclose;
  }
rx_wave_inhdr=malloc(devno*no_of_rx_wavein*(sizeof(WAVEHDR)+sizeof(DWORD)));
if(rx_wave_inhdr == NULL)
  {
  errcod=1236;
  goto errfree_inbuf;
  }
rxadin1_newbuf=(void*)&rx_wave_inhdr[devno*no_of_rx_wavein];
rxadin2_newbuf=&rxadin1_newbuf[no_of_rx_wavein];
rxadin1_newbuf_ptr=0;
rxadin2_newbuf_ptr=0;
for(i=0; i<no_of_rx_wavein; i++)
  {
  if(devno==1)
    {
    k=(int)(rx_wavein_buf+i*snd[RXAD].block_bytes+fmt.Format.nBlockAlign);
    k&=(-1-fmt.Format.nBlockAlign);
    rx_wave_inhdr[i].lpData=(char*)(k);
    rx_wave_inhdr[i].dwBufferLength=snd[RXAD].block_bytes;
    rx_wave_inhdr[i].dwBytesRecorded=0;
    rx_wave_inhdr[i].dwUser=0;
    rx_wave_inhdr[i].dwFlags=0;
    rx_wave_inhdr[i].dwLoops=0;
    rx_wave_inhdr[i].lpNext=NULL;
    rx_wave_inhdr[i].reserved=0;
    mmrs=waveInPrepareHeader(hwav_rxadin1, &rx_wave_inhdr[i], sizeof(WAVEHDR));
    if(mmrs != MMSYSERR_NOERROR)
      {
      errcod=1245;
      goto errfree;
      }
    mmrs=waveInAddBuffer(hwav_rxadin1,&rx_wave_inhdr[i], sizeof(WAVEHDR));
    if(mmrs != MMSYSERR_NOERROR)
      {
      errcod=1247;
      goto errfree;
      }
    }
  else
    {
    k=(int)(rx_wavein_buf+(2*i  )*(snd[RXAD].block_bytes>>1)+fmt.Format.nBlockAlign);
    k&=(-1-fmt.Format.nBlockAlign);
    rx_wave_inhdr[2*i  ].lpData=(char*)(k);
    rx_wave_inhdr[2*i  ].dwBufferLength=snd[RXAD].block_bytes>>1;
    rx_wave_inhdr[2*i  ].dwBytesRecorded=0;
    rx_wave_inhdr[2*i  ].dwUser=0;
    rx_wave_inhdr[2*i  ].dwFlags=0;
    rx_wave_inhdr[2*i  ].dwLoops=0;
    rx_wave_inhdr[2*i  ].lpNext=NULL;
    rx_wave_inhdr[2*i  ].reserved=0;
    mmrs=waveInPrepareHeader(hwav_rxadin1, &rx_wave_inhdr[2*i],
                                                          sizeof(WAVEHDR));
    if(mmrs != MMSYSERR_NOERROR)
      {
      errcod=1245;
      goto errfree;
      }
    mmrs=waveInAddBuffer(hwav_rxadin1,&rx_wave_inhdr[2*i  ], sizeof(WAVEHDR));
    if(mmrs != MMSYSERR_NOERROR)
      {
      errcod=1247;
      goto errfree;
      }
    k=(int)(rx_wavein_buf+(2*i+1)*(snd[RXAD].block_bytes>>1)+fmt.Format.nBlockAlign);
    k&=(-1-fmt.Format.nBlockAlign);
    rx_wave_inhdr[2*i+1].lpData=(char*)(k);
    rx_wave_inhdr[2*i+1].dwBufferLength=snd[RXAD].block_bytes>>1;
    rx_wave_inhdr[2*i+1].dwBytesRecorded=0;
    rx_wave_inhdr[2*i+1].dwUser=0;
    rx_wave_inhdr[2*i+1].dwFlags=0;
    rx_wave_inhdr[2*i+1].dwLoops=0;
    rx_wave_inhdr[2*i+1].lpNext=NULL;
    rx_wave_inhdr[2*i+1].reserved=0;
    mmrs=waveInPrepareHeader(hwav_rxadin2, &rx_wave_inhdr[2*i+1],
                                                            sizeof(WAVEHDR));
    if(mmrs != MMSYSERR_NOERROR)
      {
      errcod=1245;
      goto errfree;
      }
    mmrs=waveInAddBuffer(hwav_rxadin2,&rx_wave_inhdr[2*i+1], sizeof(WAVEHDR));
    if(mmrs != MMSYSERR_NOERROR)
      {
      errcod=1247;
      goto errfree;
      }
    }
  }
waveInStart(hwav_rxadin1);
if(devno==2)waveInStart(hwav_rxadin2);
return ;
errfree:;
free(rx_wave_inhdr);
errfree_inbuf:;
free(rx_wavein_buf);
errclose:;
if(devno==2)
  {
  waveInClose(hwav_rxadin2);
  }
waveInClose(hwav_rxadin1);
lirerr(errcod);
}

void set_rx_io(void)
{
char *tmptxt;
char *tmptxt1;
char *ss;
char s[256];
char s1[256];
char *logfile_name="soundboard_init.log";
int i, j, k, dev, line;
unsigned int device_id, no_of_addev, no_of_dadev;
MMRESULT mmrs;
WAVEINCAPS pwic;
WAVEOUTCAPS pwoc;
//if(sdr != -1)return;
sndlog = fopen(logfile_name, "w");
if(sndlog == NULL)
  {
  lirerr(1016);
  return;
  }
write_log=TRUE;
begin_rx_set_io:;
// ******************************************************************
// Show the current RX settings on the screen and do some validation
// ******************************************************************
clear_screen();
line=1;
settextcolor(14);
lir_text(2,line,"CURRENT A/D and D/A SETUP FOR RX");
line+=3;
settextcolor(7);
if( show_rx_input_settings(&line) )goto display_rx_out;
// check for input soundcards
if(ui.rx_addev_no == -1)
  {
  settextcolor(12);
  if (ui.operator_skil != OPERATOR_SKIL_NEWCOMER)
    {
    sprintf(s,"NOT YET SELECTED (SHOULD BE EITHER SOUNDCARD OR NETWORK OR SDR DEVICE)");
    }
  else
    { 
    sprintf(s,"SOUNDCARD NOT YET SELECTED: Select Menu Option A ");
    }
  lir_text(24,line,s);
  SNDLOG"\n%s",s);
  goto display_rx_out;
  }
if (ui.rx_addev_no > 255)
  {
  device_id=(ui.rx_addev_no&255);
  mmrs=waveInGetDevCaps(device_id, &pwic, sizeof(WAVEINCAPS));
  if(mmrs==MMSYSERR_NOERROR)
    {
    settextcolor(10);
    sprintf(s,"SOUNDCARD device 1 = %s ", pwic.szPname);
    lir_text(24,line,s);
    SNDLOG"\n%s",s);
    line+=1;
    sprintf(s,"device number      = %d", device_id);
    lir_text(24,line,s);
    SNDLOG"\n%s",s);
    line+=1;
    }
  else
    {
    sprintf(s,"SOUNDCARD device number %d : INVALID DEVICE ", device_id);
    settextcolor(12);
    lir_text(24,line,s);
    SNDLOG"\n%s\n",s);
    ui.rx_addev_no =-1;
    goto display_rx_out;
    }
  device_id=(ui.rx_addev_no>>8)-1;
  mmrs=waveInGetDevCaps(device_id, &pwic, sizeof(WAVEINCAPS));
  if(mmrs==MMSYSERR_NOERROR)
    {
    settextcolor(10);
    sprintf(s,"SOUNDCARD device 2 = %s ", pwic.szPname);
    lir_text(24,line,s);
    SNDLOG"\n%s",s);
    line+=1;
    sprintf(s,"device number      = %d", device_id);
    lir_text(24,line,s);
    SNDLOG"\n%s",s);
    }
  else
    {
    sprintf(s,"SOUNDCARD device number %d : INVALID DEVICE ", device_id);
    settextcolor(12);
    lir_text(24,line,s);
    SNDLOG"\n%s\n",s);
    ui.rx_addev_no=-1;
    goto display_rx_out;
    }
  }
else
  {
  device_id=ui.rx_addev_no;
  mmrs=waveInGetDevCaps(device_id, &pwic, sizeof(WAVEINCAPS));
  if(mmrs==MMSYSERR_NOERROR)
    {
    settextcolor(10);
    sprintf(s,"SOUNDCARD device   = %s ", pwic.szPname);
    lir_text(24,line,s);
    SNDLOG"\n%s",s);
    line+=1;
    sprintf(s,"device number      = %d", device_id);
    lir_text(24,line,s);
    SNDLOG"\n%s",s);
    }
  else
    {
    sprintf(s,"SOUNDCARD device number %d : INVALID DEVICE ", device_id);
    settextcolor(12);
    lir_text(24,line,s);
    SNDLOG"\n%s\n",s);
    ui.rx_addev_no=-1;
    goto display_rx_out;
    }
  }
line++;
sprintf(s,"Associated radio   = %s",soundcard_radio_names[ui.soundcard_radio]);    
settextcolor(7);
lir_text(24,line,s);
if(ui.soundcard_radio == SOUNDCARD_RADIO_WSE)
  {
  sprintf(s,"Port=%d Pin =%d",wse.parport,wse.parport_pin);
  lir_text(50,line,s);
  if (wse.parport==USB2LPT16_PORT_NUMBER)
    {
    settextcolor(10);
    sprintf(s,"USB2LPT 1.6 SELECTED");
    lir_text(70,line,s);
    settextcolor(7);
    }
  }
line+=1;
sprintf(s,"sample rate        = %i" ,ui.rx_ad_speed);
lir_text(24,line,s);
SNDLOG"\n%s",s);
line+=1;
sprintf(s,"no of input bytes  = 2 (16 bits)");
if( (ui.rx_input_mode&DWORD_INPUT) != 0)
  {
  sprintf(&s[21],"4 (32 bits)");
  }
lir_text(24,line,s);
SNDLOG"\n%s",s);
line+=1;
tmptxt=" ";
tmptxt1=" ";
if( ((ui.rx_input_mode&TWO_CHANNELS) == 0)&&((ui.rx_input_mode&IQ_DATA) == 0))
  {
  tmptxt="radio interface    = One Rx channel, one audio channels ";
  tmptxt1="                     (normal audio)";
  }
if( ((ui.rx_input_mode&TWO_CHANNELS) == 0)&&((ui.rx_input_mode&IQ_DATA) != 0))
  {
  tmptxt="radio interface    = One Rx channel, two audio channels ";
  tmptxt1="                     (direct conversion)";
  }
if( ((ui.rx_input_mode&TWO_CHANNELS) != 0)&&((ui.rx_input_mode&IQ_DATA) != 0))
  {
  tmptxt="radio interface    = Two Rx channels, four audio channels ";
  tmptxt1="                     (direct conversion, adaptive polarization)";
  }
if( ((ui.rx_input_mode&TWO_CHANNELS) != 0)&&((ui.rx_input_mode&IQ_DATA) == 0))
  {
  tmptxt="radio interface    = Two Rx channels, two audio channels ";
  tmptxt1="                     (normal audio, adaptive polarization)";
  }
lir_text(24,line,tmptxt);
SNDLOG"\n%s",tmptxt);
line+=1;
lir_text(24,line,tmptxt1);
SNDLOG"\n%s\n",tmptxt1);
// ************************************************************************
// Show the current RX OUTPUT settings on the screen and do some validation
// ************************************************************************
display_rx_out:;
settextcolor(7);
line+=3;
sprintf(s,"Linrad RX output to:");
lir_text(2,line,s);
SNDLOG"\nSETUP FOR RX OUTPUT IS NOW:\n");
settextcolor(10);
//check if network output mode
s[0]='\0';
if((ui.network_flag & NET_RXOUT_RAW16) != 0)  strncat ( s,"RAW16 ",6);
if((ui.network_flag & NET_RXOUT_RAW18) != 0)  strncat ( s,"RAW18 ",6);
if((ui.network_flag & NET_RXOUT_RAW24) != 0)  strncat ( s,"RAW24 ",6);
if((ui.network_flag & NET_RXOUT_FFT1)  != 0)  strncat ( s,"FFT1 ",6);
if((ui.network_flag & NET_RXOUT_TIMF2) != 0)  strncat ( s,"TIMF2 ",6);
if((ui.network_flag & NET_RXOUT_FFT2)  != 0)  strncat ( s,"FFT2 ",6);
if((ui.network_flag & NET_RXOUT_BASEB)  != 0)  strncat ( s,"BASEB16 ",9);
if((ui.network_flag & NET_RXOUT_BASEBRAW) != 0)  strncat ( s,"BASEB24 ",9);
if (strlen(s) != 0)
  {
  sprintf(s1,"NETWORK");
  lir_text(24,line,s1);
  SNDLOG"\n%s",s1);
  settextcolor(7);
  line+=1;
  sprintf(s1,"send format        = %s",s);
  lir_text(24,line,s1);
  SNDLOG"\n%s\n",s1);
  line+=2;
  settextcolor(10);
//disable output soundcard if not yet selected
  if(ui.rx_dadev_no == -1)  ui.rx_dadev_no =-2;
  }
//check for output soundcards
if(ui.rx_dadev_no < 0)
  {
  if(ui.rx_dadev_no == -1)
    {
    settextcolor(12);
    if (ui.operator_skil != OPERATOR_SKIL_NEWCOMER)
       sprintf(s,"NOT YET SELECTED (SHOULD BE EITHER SOUNDCARD OR DISABLED, AND/OR NETWORK)");
    else 
       sprintf(s,"SOUNDCARD NOT YET SELECTED OR DISABLED: Select Menu Option B or Z ");
    lir_text(24,line,s);
    SNDLOG"\n%s\n",s);
    goto set_rx_io_ask;
    }
  else
    {
    ui.rx_dadev_no=-2;
    sprintf(s,"SOUNDCARD DISABLED");
    lir_text(24,line,s);
    SNDLOG"\n%s",s);
    settextcolor(7);
    line+=1;
    sprintf(s,"max dma rate       = %i" ,ui.max_dma_rate);
    lir_text(24,line,s);
    SNDLOG"\n%s\n",s);
    goto set_rx_io_ask;
    }
  }
else
  {
#if PORTAUDIO_PRESENT == 1
  if ( (ui.use_alsa&PORTAUDIO_RX_OUT) != 0)
    {
    int err;
    char pa_device_name[128];
    char pa_device_hostapi  [128];
    double pa_device_max_speed;
    double pa_device_min_speed;
    int pa_device_max_bytes;
    int pa_device_min_bytes;
    int pa_device_max_channels;
    int pa_device_min_channels;
    err=pa_get_device_info (ui.rx_dadev_no,
                          RXDA,
                          &pa_device_name,
                          &pa_device_hostapi,
			  &pa_device_max_speed,
			  &pa_device_min_speed,
			  &pa_device_max_bytes,
			  &pa_device_min_bytes,
			  &pa_device_max_channels,
			  &pa_device_min_channels );
    if (err == 0)
      {
      sprintf(s,"SOUNDCARD device   = %s ", pa_device_name);
      lir_text(24,line,s);
      SNDLOG"\n%s",s);
      line+=1;
      sprintf(s,"device number      = %d", ui.rx_dadev_no);
      lir_text(24,line,s);
      SNDLOG"\n%s",s);
      line+=1;
      sprintf(s,"hostapi            = Portaudio (%s)", pa_device_hostapi);
      lir_text(24,line,s);
      SNDLOG"\n%s",s);
      ui.rx_min_da_speed=pa_device_min_speed;
      ui.rx_max_da_speed=pa_device_max_speed;
      ui.rx_min_da_bytes=pa_device_min_bytes;
      ui.rx_max_da_bytes=pa_device_max_bytes;
      ui.rx_min_da_channels=pa_device_min_channels;
      ui.rx_max_da_channels=pa_device_max_channels;
      }
    else
      {
      sprintf (s,"PORTAUDIO device number %d : INVALID DEVICE ",ui.rx_dadev_no );
      settextcolor(12);
      lir_text(24,line,s);
      SNDLOG"\n%s",s);
      ui.rx_dadev_no=-1;
      goto  set_rx_io_ask;
      }
    }
  else
#else
  ui.use_alsa&=WAVE_FORMAT_EXTENSIBLE_USED;
#endif
    {
    device_id=ui.rx_dadev_no;
    mmrs=waveOutGetDevCaps(device_id, &pwoc, sizeof(WAVEOUTCAPS));
    if(mmrs==MMSYSERR_NOERROR)
      {
      sprintf(s,"SOUNDCARD device   = %s ", pwoc.szPname);
      lir_text(24,line,s);
      SNDLOG"\n%s",s);
      line+=1;
      sprintf(s,"device number      = %d", device_id);
      lir_text(24,line,s);
      SNDLOG"\n%s",s);
      line+=1;
      sprintf(s,"hostapi            = Native MME ");
      lir_text(24,line,s);
      SNDLOG"\n%s",s);
      }
    else
      {
      sprintf(s,"SOUNDCARD device number %d : INVALID DEVICE ", device_id);
      settextcolor(12);
      lir_text(24,line,s);
      ui.rx_dadev_no=-1;
      SNDLOG"\n%s\n",s);
      goto  set_rx_io_ask;
      }
    }
  settextcolor(7);
  line+=1;
  sprintf(s,"min da sample rate = %i" ,ui.rx_min_da_speed);
  lir_text(24,line,s);
  SNDLOG"\n%s",s);
  line+=1;
  sprintf(s,"max da sample rate = %i" ,ui.rx_max_da_speed);
  lir_text(24,line,s);
  SNDLOG"\n%s",s);
  line+=1;
  sprintf(s,"min da bytes       = %i" ,ui.rx_min_da_bytes);
  lir_text(24,line,s);
  SNDLOG"\n%s",s);
  line+=1;
  sprintf(s,"max da bytes       = %i" ,ui.rx_max_da_bytes);
  lir_text(24,line,s);
  SNDLOG"\n%s",s);
  line+=1;
  sprintf(s,"min da channels    = %i" ,ui.rx_min_da_channels);
  lir_text(24,line,s);
  SNDLOG"\n%s",s);
  line+=1;
  sprintf(s,"max da channels    = %i" ,ui.rx_max_da_channels);
  lir_text(24,line,s);
  SNDLOG"\n%s",s);
  line+=2;
  sprintf(s,"max dma rate       = %i" ,ui.max_dma_rate);
  lir_text(24,line,s);
  SNDLOG"\n%s\n",s);
  line++;
  }
set_rx_io_ask:;
if(ui.converter_hz != 0 || ui.converter_mhz != 0)
  {
  compute_converter_parameters();
  settextcolor(10);
  line+=2;  
  lir_text(24,line,"CONVERTER");
  sprintf(s,"LO frequency %.6f",converter_offset_mhz);
  i=0;
  while(s[i] != 0)i++;
  while(s[i-1] == '0')i--;
  if(s[i-1] == '.')i--;
  sprintf(&s[i]," MHz.  LO is ");
  if(ui_converter_direction > 0)
    {
    strcat(s,"below");
    }
  else
    {
    strcat(s,"above");
    }
  strcat(s," signal frequency.");
  settextcolor(7);
  lir_text(35,line,s);
  line++;
  }
// ***************************************************************************
// Ask whether the user wants to change settings and act accordingly:
// ***************************************************************************
settextcolor(7);
line+=3;
lir_text(2,line,"A = Change the input settings and reset the output soundcard settings if a soundcard is selected as input.");
line++;
lir_text(2,line,"B = Change the output soundcard settings.");
line++;
if(ui.operator_skil != OPERATOR_SKIL_NEWCOMER)
  {
  lir_text(2,line,"C = Change max dma rate.");
  line++;
  }
if(ui.soundcard_radio != SOUNDCARD_RADIO_UNDEFINED)
  {
  lir_text(2,line,"D = Set parameters for soundcard radio hardware.");
  line++;
  }
if(ui.operator_skil != OPERATOR_SKIL_NEWCOMER)
  {
  lir_text(2,line,"E = Enable/Disable frequency converter and set shift.");
  line++;
  }
  lir_text(2,line,"Z = Disable the output soundcard.");
line++;
lir_text(2,line,"X = To main menu.");
if(ui.operator_skil != OPERATOR_SKIL_NEWCOMER)
  {
  settextcolor(11);
  line+=2;
  lir_text(2,line,"NOTE: To select/change NETWORK settings for input or output: Select first a valid input output configuration");
  line+=1;
  lir_text(2,line,"with this menu. Next go to the main menu ( option X ) and select NETWORK options ( N or R or T) there.");
  settextcolor(7);
  }
process_keyboard:;
await_processed_keyboard();
if(kill_all_flag) return;
switch(lir_inkey)
  {
  case 'A':
// ************************** CHANGE INPUT SETTINGS ************************************ //
  if(ui.operator_skil != OPERATOR_SKIL_NEWCOMER)
    {
    if((ui.network_flag&NET_RX_INPUT) != 0)
      {
      settextcolor(11);
      line+=2;
      lir_text(2,line,"Option A selected, but changes to NETWORK settings must be selected from the main menu:");
      line+=1;
      lir_text(2,line,"Hit any key to go back to this menu and select there option X .");
      settextcolor(7);
      await_processed_keyboard();
      break;
      }
    }
  SNDLOG"\nUSER STARTED THE SELECTION OF A NEW INPUT DEVICE \n");
  clear_screen();
  lir_text(10,2,"SELECT HARDWARE FOR INPUT");
  lir_text(4,4,"A = Soundcard");
  lir_text(4,5,"B = SDR-14 or SDR-IQ");
  lir_text(4,6,"C = Perseus");
  lir_text(4,7,"D = SDR-IP");
  lir_text(4,8,"E = Excalibur");
  await_processed_keyboard();
  if(kill_all_flag)goto set_rx_io_errexit;
  clear_screen();
  switch (lir_inkey)
    {
    case 'A':
    goto use_sndcard;
    
    case 'B':
    timf1_char=malloc(0x8000);
    if(timf1_char == NULL)
      {
      lirerr(1231231);
      return;
      }
    init_sdr14();
    free(timf1_char);
    break;
    
    case 'C':
    init_perseus();
    break;
    
    case 'D':
    init_sdrip();
    break;

    case 'E':
    init_excalibur();
    break;
    }
  if(kill_all_flag)goto set_rx_io_errexit;
  if(ui.rx_addev_no == -1)goto begin_rx_set_io;
  break;
use_sndcard:;
  clear_screen();
// reset the output soundcard 
  ui.rx_dadev_no =-1;
  ui.rx_addev_no=-1;
  clear_screen();
// Find out how many audio input devices there are on this computer.
// Allow the user to select one or two for the rx input.
get_dev2_q:;
  settextcolor(14);
  lir_text(10,0,"Select SOUNDCARD device for RX input from list ");
  settextcolor(7);
  no_of_addev=waveInGetNumDevs();
  if(no_of_addev == 0)
    {
    lir_text(10,2,"No soundcard detected.");
    lir_text(10,3,press_any_key);
    await_keyboard();
    break;
    }
  line=2;
  k=0;
  if(no_of_addev > MAX_WAV_DEVICES)no_of_addev=MAX_WAV_DEVICES;
  for(device_id=0; device_id<no_of_addev; device_id++)
    {
    mmrs=waveInGetDevCaps(device_id, &pwic, sizeof(WAVEINCAPS));
    if(mmrs==MMSYSERR_NOERROR)
      {
      sprintf(s,"%d  %s", device_id, pwic.szPname);
      settextcolor(7);
      k++;
      }
    else
      {
      sprintf(s,"%d ERROR (mmrs=%d) %s", device_id, mmrs, pwic.szPname);
      settextcolor(3);
      }
    lir_text(10,line,s);
    line++;
    }
  line+=2;
  settextcolor(7);
  if(k == 0)
    {
    lir_text(10,line,"No usable input device found.");
    line+=2;
    lir_text(14,line,press_any_key);
    await_keyboard();
    break;
    }
  if(no_of_addev == 1)
    {
    ui.rx_addev_no=0;
    }
  else
    {
    if(ui.rx_addev_no == -1)
      {
      if(ui.operator_skil != OPERATOR_SKIL_NEWCOMER)
        {
        ss="(first)";
        }
      else
        {
        ss="";
        }
    sprintf(s,"Select %s device for Rx input by line number>",ss);
    lir_text(10,line,s);
    ui.rx_addev_no=lir_get_integer(61,line, 2, 0, no_of_addev-1);
    if(kill_all_flag) return;
    }
  else
    {
    sprintf(s,"Selected device is %d",ui.rx_addev_no);
    lir_text(10,line,s);
    }
  line++;
  if(ui.operator_skil != OPERATOR_SKIL_NEWCOMER)
    {
    lir_text(10,line,
                 "Do you need more channels from the same soundcard ? (Y/N)");
    lir_text(10,line+1,"F1 for info/help");
get_dev2:;
    toupper_await_keyboard();
    if(lir_inkey == F1_KEY)
      {
      help_message(323);
      clear_screen();
      goto get_dev2_q;
      }
    if(kill_all_flag) return;
    if(lir_inkey == 'Y')
      {
      line++;
      lir_text(10,line,"Select a second device for Rx input>");
dev2_n:;
      i=lir_get_integer(47,line, 2, 0, no_of_addev-1);
      if(kill_all_flag) return;
      if(i==ui.rx_addev_no)goto dev2_n;
      ui.rx_addev_no+=256*(i+1);
      }
    else
      {
      if(lir_inkey != 'N')goto get_dev2;
      }
    }
  }
// Windows does not allow us to query the device for its capabilities.
// Ask the user to specify what he wants.
  line+=2;
  lir_text(10,line,"Linrad can not query hardware because Windows will report that");
  line++;
  lir_text(10,line,"everything is possible. Windows will silently resample and provide");
  line++;
  lir_text(10,line,"data that would be meaningless in an SDR context.");
  line++;
  lir_text(10,line,"Therefore, make sure you enter data that is compatible with the");
  line++;
  lir_text(10,line,"native capabilities of your soundcardhardware. (And make sure that");
  line++;
  lir_text(10,line,"the soundcard really is set to the speed you have selected.)");
  line+=2;
  if(ui.operator_skil != OPERATOR_SKIL_NEWCOMER)
  {
get_wavfmt:;
  lir_text(10,line,"Use extended format (WAVEFORMATEXTENSIBLE) ? (Y/N)");
  lir_text(10,line+1,"F1 for info/help");
getfmt:;
  toupper_await_keyboard();
  if(lir_inkey == F1_KEY)
    {
    help_message(324);
    clear_screen();
    goto get_wavfmt;
    }
  if(lir_inkey == 'N')
      {
      ui.use_alsa&=~WAVE_FORMAT_EXTENSIBLE_USED;
      }
    else
      {
      if(lir_inkey != 'Y')goto getfmt;
      ui.use_alsa|=WAVE_FORMAT_EXTENSIBLE_USED;
      }
    line++;
    clear_lines(line,line);
    line++;
    }
  else
    {
    ui.use_alsa&=~WAVE_FORMAT_EXTENSIBLE_USED;
    }
get_rxinrate:;
  lir_text(10,line,"Sampling speed (Hz)>");
  ui.rx_ad_speed=lir_get_integer(31,line, 6, 5000, 999999);
  if(kill_all_flag) return;
  if((ui.use_alsa&WAVE_FORMAT_EXTENSIBLE_USED) == WAVE_FORMAT_EXTENSIBLE_USED)
    {
get_rxbits:;
    lir_text(40,line,"No of bits (16/24):");
    i=lir_get_integer(60,line, 2, 16, 24);
    if(kill_all_flag) return;
    clear_screen();
    if(i==16)
      {
      ui.rx_input_mode=0;
      }
    else
      {
      if(i==24)
        {
        ui.rx_input_mode=DWORD_INPUT;
        }
      else
        {
        goto get_rxbits;
        }
      }
    }
  else
    {
    ui.rx_input_mode=0;
    }
  clear_screen();
// Check whether the device(s) can do whatever the user asked for.
// Try to open with four channels.
// Try again with two channels on error.
  dev=ui.rx_addev_no&255;
  j=8;
test_channels:;
  j/=2;
  fill_wavefmt(j,16);
  mmrs=waveInOpen(&hwav_rxadin1, dev, (WAVEFORMATEX*)&fmt, 0, 0,
                                   WAVE_FORMAT_QUERY|WAVE_FORMAT_DIRECT);
  if(mmrs != MMSYSERR_NOERROR)
    {
    if(j==4)goto test_channels;
    if(mmrs == MMSYSERR_ALLOCATED)lirerr(1218);
    if(mmrs == MMSYSERR_BADDEVICEID)lirerr(1219);
    if(mmrs == MMSYSERR_NODRIVER)lirerr(1220);
    if(mmrs == MMSYSERR_NOMEM)lirerr(1221);
    if(mmrs == WAVERR_BADFORMAT)lirerr(1222);
    lirerr(1238);
    return;
    }
  if(ui.rx_addev_no>255)
    {
    dev=(ui.rx_addev_no>>8)-1;
    mmrs=waveInOpen(&hwav_rxadin1, dev, (WAVEFORMATEX*)&fmt, 0, 0,
                WAVE_FORMAT_QUERY|WAVE_FORMAT_DIRECT);
    if(mmrs != MMSYSERR_NOERROR)
      {
      lir_text(0,line+2,
           "ERROR  Format not supported by second device. (Press any key)");
      await_keyboard();
      if(kill_all_flag) return;
      clear_screen();
      waveInClose(hwav_rxadin1);
      goto get_rxinrate;
      }
    waveInClose(hwav_rxadin2);
    }
  waveInClose(hwav_rxadin1);
  if(ui.rx_input_mode==DWORD_INPUT)
    {
    if( (ui.use_alsa&WAVE_FORMAT_EXTENSIBLE_USED) == 0)lirerr(5823198);
    fill_wavefmt(j,24);
    mmrs=waveInOpen(&hwav_rxadin1, dev, (WAVEFORMATEX*)&fmt, 0, 0,
                                   WAVE_FORMAT_QUERY|WAVE_FORMAT_DIRECT);
    if(mmrs != MMSYSERR_NOERROR)
      {
      clear_screen();
      lir_text(5,5,"Can not use 24 bit A/D. Will use 16 bits instead.");
      lir_text(5,7,press_any_key);
      await_keyboard();
      ui.rx_input_mode=0;
      }
    waveInClose(hwav_rxadin1);
    }
  if(ui.rx_addev_no>255 && j<4)j*=2;
// If we have reached this far, the user has given correct info about
// speed, channels and no of bits.
// Ask for the desired processing mode.
sel_radio:;
  clear_screen();
  lir_text(10,10,"Select radio interface>");
  if(j == 2)j=3;
  for(i=0; i<j; i++)
    {
    sprintf(s,"%d: %s",i+1,audiomode_text[i]);
    lir_text(10,12+i,s);
    }
  lir_text(10,13+i,"F1 for help/info");
  line=15+i;
chsel:;
  await_processed_keyboard();
  if(lir_inkey == F1_KEY)
    {
    help_message(89);
    goto sel_radio;
    }
  if(lir_inkey-'0'>j)goto chsel;
  switch (lir_inkey)
    {
    case '1':
    ui.rx_rf_channels=1;
    ui.rx_ad_channels=1;
    break;

    case '2':
    ui.rx_input_mode|=IQ_DATA;
    ui.rx_rf_channels=1;
    ui.rx_ad_channels=2;
   break;

    case '3':
    ui.rx_input_mode|=TWO_CHANNELS;
    ui.rx_rf_channels=2;
    ui.rx_ad_channels=2;
    break;

    case '4':
    ui.rx_input_mode|=TWO_CHANNELS+IQ_DATA;
    ui.rx_rf_channels=2;
    ui.rx_ad_channels=4;
    break;

    default:
    goto chsel;
    }
// Input seems OK.
  clear_screen();
  line=4;
  lir_text(9,line,"Select receiver hardware to use with soundcard.");
  line+=3;
  for(i=0; i<MAX_SOUNDCARD_RADIO; i++)
    {
    sprintf(s,"%d   %s",i,soundcard_radio_names[i]);
    lir_text(5,line,s);
    line++;
    }
  line++;
  lir_text(0,line,"Select by line number=>");
  ui.soundcard_radio=lir_get_integer(25,line,1,0,MAX_SOUNDCARD_RADIO);
  break;

  case 'B':
// ************************** CHANGE OUTPUT SETTINGS ************************************ //
  j=0;
  if ((ui.rx_addev_no < 0 )  &&  ((ui.network_flag&NET_RX_INPUT)==0) ) 
    {
    settextcolor(11);
    line+=2;
    lir_text(2,line,"Option B selected, but RX input must be set first:");
    line+=1;
    lir_text(2,line,"Hit any key to go back to this menu and select option A");
    settextcolor(7);
    await_processed_keyboard();
    break;
    }
  SNDLOG"\nUSER STARTED THE SELECTION OF A NEW OUTPUT DEVICE \n");
// Open input soundcard  if soundcard valid and network input is not set, but do not start recording.
// This way we can (probably) avoid problems with old soundcards
// that do not have duplex capabilities.
  if (( ui.rx_addev_no >= 0  && ui.rx_addev_no < SPECIFIC_DEVICE_CODES )
                                        && (ui.network_flag&NET_RX_INPUT)==0)
    {
// Set a reasonable block size.    
    snd[RXAD].block_bytes=8192;
    open_rx_sndin();
    if(kill_all_flag)return;
    }
  clear_screen();
  ui.rx_dadev_no=-1;
#if PORTAUDIO_PRESENT == 1
  lir_text(10,5,"Use Portaudio for rx output? (Y/N) =>");
pa_rxda:;
  await_processed_keyboard();
  if(lir_inkey == 'N')
    {
    ui.use_alsa&=~PORTAUDIO_RX_OUT;
    }
  else
    {
    if(lir_inkey != 'Y')
      {
      goto pa_rxda;
      }
    ui.use_alsa|=PORTAUDIO_RX_OUT;
    }
  portaudio_startstop();
//get a 'portaudio' selection list
  clear_screen();
  if( (ui.use_alsa&PORTAUDIO_RX_OUT) != 0)
    {
    set_portaudio(RXDA, &line);
    goto set_rxout_exit;
    }
#endif
//get a 'native MME' selection list
  no_of_dadev=waveOutGetNumDevs();
  if(no_of_dadev == 0)
    {
    lir_text(5,2,"No output device detected");
    if(ui.rx_addev_no < SPECIFIC_DEVICE_CODES)
                                   lir_text(5,28,"while input is open.");
    lir_text(5,3,"PRESS ANY KEY");
    await_keyboard();
    break;
    }
  settextcolor(14);
  lir_text(10,0,"Select SOUNDCARD device for Rx output");
  settextcolor(7);
  line=2;
  if(no_of_dadev > MAX_WAV_DEVICES)no_of_dadev=MAX_WAV_DEVICES;
  for(device_id=0; device_id<no_of_dadev; device_id++)
    {
    mmrs=waveOutGetDevCaps(device_id, &pwoc, sizeof(WAVEOUTCAPS));
    if(mmrs==MMSYSERR_NOERROR)
      {
      sprintf(s,"%d  %s", device_id, pwoc.szPname);
      lir_text(10,line,s);
      line++;
      }
    }
  line+=2;
  if(no_of_dadev == 1)
    {
    ui.rx_dadev_no=0;
    }
  else
    {
    lir_text(10,line,"Select device for Rx output by line number>");
    ui.rx_dadev_no=lir_get_integer(54,line, 2, 0, no_of_dadev-1);
    if(kill_all_flag) return;
    line+=2;
    }
  ui.rx_max_da_channels=2;
  ui.rx_min_da_channels=1;
  mmrs=waveOutGetDevCaps(ui.rx_dadev_no, &pwoc, sizeof(WAVEOUTCAPS));
  i=0;
  if( (pwoc.dwFormats &
           (WAVE_FORMAT_1M08|WAVE_FORMAT_2M08|WAVE_FORMAT_4M08|
            WAVE_FORMAT_1S08|WAVE_FORMAT_2S08|WAVE_FORMAT_4S08)) != 0)i=1;
  if( (pwoc.dwFormats &
           (WAVE_FORMAT_1M16|WAVE_FORMAT_2M16|WAVE_FORMAT_4M16|
            WAVE_FORMAT_1S16|WAVE_FORMAT_2S16|WAVE_FORMAT_4S16)) != 0)i|=2;
  if(i==0 || i==3)
    {
    ui.rx_max_da_bytes=2;
    ui.rx_min_da_bytes=1;
    }
  else
    {
    ui.rx_max_da_bytes=j;
    ui.rx_min_da_bytes=j;
    }
  ui.rx_min_da_speed=8000;
  ui.rx_max_da_speed=96000;
  sprintf(s,"%s selected for Rx audio output.", pwoc.szPname);
  lir_text(10,line,s);
#if PORTAUDIO_PRESENT == 1
set_rxout_exit:;
#endif
  if (( ui.rx_addev_no >= 0  && ui.rx_addev_no < SPECIFIC_DEVICE_CODES )
                                        && (ui.network_flag&NET_RX_INPUT)==0) 
                                                               close_rx_sndin();
  break; 

  case 'C':
// ************************** CHANGE DMA RATE ************************************ //
  if(ui.operator_skil != OPERATOR_SKIL_NEWCOMER)
    {
    clear_screen();
    line=5;
    SNDLOG"\nUSER STARTED A CHANGE OF MAX DMA RATE\n");
    sprintf(s,"Current  max DMA rate in Hz           : %i ",ui.max_dma_rate);
    lir_text(10,line,s);
    SNDLOG"%s\n",s);
    line+=2;
    sprintf(s,"Enter new max DMA rate in Hz (10-999) > ");
    SNDLOG"%s\n",s);
    lir_text(10,line,s);
    i=lir_get_integer(50, line, 3, 10,999);
    if(kill_all_flag) return;
    sprintf(s,"User selected  %i",i);
    SNDLOG"%s\n",s);
    ui.max_dma_rate=i;
    }
  break;

  case 'D':
  switch (ui.soundcard_radio)
    {
    case SOUNDCARD_RADIO_WSE:
    wse_setup();
    break;
    
    case SOUNDCARD_RADIO_SI570:
#if LIBUSB_PRESENT == 1
    si570_setup();
#else
    clear_screen(); 
    lir_text(5,5,"Si570 not supported");
    lir_text(5,7,"Install libusb.a and usb.h in your mingw directory.");
    lir_text(5,8,"Then run configure and make.");
    lir_text(8,10,press_any_key);
    await_processed_keyboard();
#endif   
    break;
    }
  break;  

  case 'E':
  clear_screen();
// *************************  CONVERTER SETUP FOR RX ****************************
  lir_text(5,3,"Do you wish to use a converter in front of your receiver (Y/N)?");
get_convuse:;
  await_processed_keyboard();
  if(lir_inkey=='N')
    {
    ui.converter_hz=0;  
    ui.converter_mhz=0;  
    compute_converter_parameters();
    break;
    }
  else
    {
    if(lir_inkey != 'Y')goto get_convuse;
    }
  lir_text(5,5,"Enter converter LO frequency in MHz:");
  converter_offset_mhz=lir_get_float(42,5,14,0.001,200000.);
  ui.converter_mhz=converter_offset_mhz;
  ui.converter_hz=round(1000000*(converter_offset_mhz-ui.converter_mhz));
  get_losign:;
  lir_text(5,7,"Is LO below signal frequency (Y/N)?");
  await_processed_keyboard();
  if(lir_inkey=='Y')
    {
    ui_converter_direction=1; 
    }
  else
    {
    ui_converter_direction=-1; 
    if(lir_inkey != 'N')goto get_losign;
    ui.converter_hz=-ui.converter_hz-1;  
    }
  compute_converter_parameters();
  break;

  case 'Z':
// ************************** DISABLE OUTPUT ************************************ //
  SNDLOG"\nUSER DISABLED THE OUPUT SOUNDCARD \n");
  ui.rx_dadev_no=-2;
  ui.rx_max_da_bytes=2;
  ui.rx_max_da_channels=2;
  ui.rx_min_da_bytes=1;
  ui.rx_min_da_channels=1;
  ui.rx_min_da_speed=5000;
  ui.rx_max_da_speed=1000000;
  break;

  case 'X':
// ************************** EXIT TO MAIN MENU ********************************** //
//validate input settings
  if ((ui.rx_addev_no==-1) && ((ui.network_flag&NET_RX_INPUT)==0))
    {
    settextcolor(12);
    line+=2;
    lir_text(2,line,"Invalid input settings: NOT YET SELECTED");
    line+=1;
    lir_text(2,line,"Hit any key to go back to this menu and select option A");
    settextcolor(7);
    await_processed_keyboard();
    if (kill_all_flag) goto set_rx_io_errexit;
    break;
    } 
//validate output settings
  if (ui.rx_dadev_no==-1)
    {
    settextcolor(12);
    line+=2;
    lir_text(2,line,"Invalid output settings: NOT YET SELECTED");
    line+=1;
    lir_text(2,line,"Hit any key to go back to this menu and select option B or Z");
    settextcolor(7);
    await_processed_keyboard();
    if (kill_all_flag) goto set_rx_io_errexit;
    break;
    } 
//reurn to main menu
  line+=2;
  lir_text(2,line,remind_parsave);
  line++;
  lir_text(2,line,press_any_key);
  await_keyboard();
  goto set_rx_io_exit;
  default:
  goto process_keyboard;
  }
// ******************************************************************************** //
goto begin_rx_set_io;
set_rx_io_exit:;
SNDLOG"\nNormal end");
set_rx_io_errexit:;
fclose(sndlog);
write_log=FALSE;
return;
}

void open_rx_sndout(void)
{
int errcod;
WAVEFORMATEX wfmt;
MMRESULT mmrs;
int i, k;
float t1;
if(rx_audio_out == 0)return;
snd[RXDA].framesize=rx_daout_channels*rx_daout_bytes;
t1=min_delay_time;
i=4;
if(diskread_flag >= 2)i=1;
if(t1 < fft3_blocktime/i)t1=fft3_blocktime/i;
if(t1 > 1)t1=1;
snd[RXDA].block_frames=0.75*t1*genparm[DA_OUTPUT_SPEED];
make_power_of_two(&snd[RXDA].block_frames);
// make the minimum block 32 frames
if(snd[RXDA].block_frames < 32)snd[RXDA].block_frames=32;
make_power_of_two(&snd[RXDA].block_frames);
snd[RXDA].interrupt_rate=(float)(genparm[DA_OUTPUT_SPEED])/
                                                     snd[RXDA].block_frames;
while(snd[RXDA].interrupt_rate > ui.max_dma_rate)
  {
  snd[RXDA].interrupt_rate/=2;
  snd[RXDA].block_frames*=2;
  }
while(snd[RXDA].interrupt_rate < 10 && snd[RXDA].block_frames > 32)
  {
  snd[RXDA].interrupt_rate*=2;
  snd[RXDA].block_frames/=2;
  }
DEB"\nRXout interrupt_rate: Desired %f",snd[RXDA].interrupt_rate);
// Allocate buffers for minimum 0.3 seconds.
snd[RXDA].block_bytes=snd[RXDA].block_frames*snd[RXDA].framesize;
snd[RXDA].no_of_blocks=0.3*snd[RXDA].interrupt_rate;
make_power_of_two(&snd[RXDA].no_of_blocks);
if(snd[RXDA].no_of_blocks < 8)snd[RXDA].no_of_blocks=8;
snd[RXDA].tot_bytes=snd[RXDA].no_of_blocks*snd[RXDA].block_bytes;
snd[RXDA].tot_frames=snd[RXDA].no_of_blocks*snd[RXDA].block_frames;
if(ui.rx_dadev_no == -2)return;
#if PORTAUDIO_PRESENT == 1
if( (ui.use_alsa&PORTAUDIO_RX_OUT) != 0)
  {
  open_portaudio_rxda();
  return;
  }
#endif
wfmt.wFormatTag=WAVE_FORMAT_PCM;
wfmt.nSamplesPerSec=genparm[DA_OUTPUT_SPEED];
wfmt.wBitsPerSample=8*rx_daout_bytes;
wfmt.cbSize=0;
wfmt.nChannels=rx_daout_channels;
wfmt.nBlockAlign=wfmt.nChannels*wfmt.wBitsPerSample/8;
wfmt.nAvgBytesPerSec=wfmt.nBlockAlign*wfmt.nSamplesPerSec;
mmrs=waveOutOpen(&hwav_rxdaout, ui.rx_dadev_no,
                            &wfmt, (DWORD)rx_daout, 0, CALLBACK_FUNCTION);
if(mmrs != MMSYSERR_NOERROR)
  {
  lirerr(1234);
  return;
  }
errcod=1237;
rx_waveout_buf=malloc(snd[RXDA].no_of_blocks*snd[RXDA].block_bytes+wfmt.nBlockAlign);
if(rx_waveout_buf==NULL)goto wave_close;
rx_wave_outhdr=malloc(snd[RXDA].no_of_blocks*sizeof(WAVEHDR));
if(rx_wave_outhdr==NULL)goto free_waveout;
rxdaout_newbuf=malloc(snd[RXDA].no_of_blocks*sizeof(WAVEHDR));
if(rxdaout_newbuf==NULL)goto free_outhdr;
rxdaout_newbuf_ptr=0;
for(i=0; i<snd[RXDA].no_of_blocks; i++)
  {
  k=(int)(rx_waveout_buf+i*snd[RXDA].block_bytes+wfmt.nBlockAlign);
  k&=(-1-wfmt.nBlockAlign);
  rx_wave_outhdr[i].lpData=(char*)(k);
  rx_wave_outhdr[i].dwBufferLength=snd[RXDA].block_bytes;
  rx_wave_outhdr[i].dwBytesRecorded=0;
  rx_wave_outhdr[i].dwUser=1;
  rx_wave_outhdr[i].dwFlags=0;
  rx_wave_outhdr[i].dwLoops=0;
  rx_wave_outhdr[i].lpNext=NULL;
  rx_wave_outhdr[i].reserved=0;
  mmrs=waveOutPrepareHeader(hwav_rxdaout, &rx_wave_outhdr[i], sizeof(WAVEHDR));
  rxdaout_newbuf[i]=&rx_wave_outhdr[i];
  if(mmrs != MMSYSERR_NOERROR)goto errfree;
  }
rx_audio_out=0;
return;
errfree:;
free(rxdaout_newbuf);
free_outhdr:;
free(rx_wave_outhdr);
free_waveout:;
free(rx_waveout_buf);
wave_close:;
waveOutClose(hwav_rxdaout);
rx_audio_out=-1;
lirerr(errcod);
}

void set_tx_io(void){};

